/*
 * configview.h
 *
 *  Created on: 01.03.2009
 *      Author: darkstar
 */

#ifndef CONFIGVIEW_H_
#define CONFIGVIEW_H_

#ifdef QT4
#include <QScrollArea>
#else
#include <qscrollview.h>
#endif

#include "configuration.h"

class BaseConfigView
{
public:
	BaseConfigView(Configuration& configuration);
	virtual ~BaseConfigView();

	virtual Configuration& config() { return config_; }

	virtual void setStatesByConfiguration(const Configuration& config);
	virtual void saveStatesToConfiguration();

protected:
	friend class ConfigurationDialog;
	virtual void createWidgets();

private:
	Configuration& config_;
};

class ConfigWidget : public QWidget, public BaseConfigView
{
public:
	ConfigWidget(Configuration& configuration, QWidget *parent = 0);
	virtual ~ConfigWidget();
	QWidget *widget() { return this; }
};

#ifdef QT4

class ConfigView : public QScrollArea, public BaseConfigView
{
public:
	ConfigView(Configuration& configuration, QWidget *parent = 0);
	virtual ~ConfigView();
};

#else

class ConfigView : public QScrollView, public BaseConfigView
{
public:
	ConfigView(Configuration& configuration, QWidget *parent = 0);
	virtual ~ConfigView();

	QWidget *widget() { return widget_; }

private:
	QWidget *widget_;
};

#endif

#endif /* CONFIGVIEW_H_ */
