#ifndef FORMATSCONFIG_H_INCLUDED
#define FORMATSCONFIG_H_INCLUDED

#include "configuration.h"
#include "configview.h"

class QPushButton;
class QTreeWidget;
class QTreeWidgetItem;

class FormatsConfig : public ConfigView
{
	Q_OBJECT
public:
	FormatsConfig(Configuration& configuration, QWidget *parent = 0) : ConfigView(configuration, parent) {}

	virtual void setStatesByConfiguration(const Configuration& config);
	virtual void saveStatesToConfiguration();

protected:
	virtual void createWidgets();

private slots:
	void editFormat(QTreeWidgetItem *, int);
	void editSelectedFormat();
	void addNewFormat();
	void removeSelectedFormat();
	void revertToDefaultFormats();

private:
	void readFromConfiguration(const Configuration& config);

	QPushButton *keyButton_;
	QTreeWidget *list;
};

#endif // FORMATSCONFIG_H_INCLUDED
